#include <posix/string.h> 
#include <File.h>
#include <stdio.h>

struct FileName { char* name; };

int main()
{
	FileName files[] = { "./libbe.so",
	                     "./app_server",
	                     NULL };
	
	// find a pattern in a file
	
	// The old 'hand' pattern, this will be replaced with ...
	static unsigned char hand[] = {
		16,		// Size
		1,		// bit depth
		2,		// hot spotx
		2,		// hot spoty
		
		// Cursor shape
		0,0,0,0,56,0,36,0,36,0,19,224,18,92,9,42,
		8,1,60,1,76,1,66,1,48,1,12,1,2,0,1,0,
		
		// Mask shape
		0,0,0,0,56,0,60,0,60,0,31,224,31,252,15,254,
		15,255,63,255,127,255,127,255,63,255,15,255,3,254,1,248
	};
	
	// The -new- (old really) arrow cursor
	static unsigned char arrow[] = {
		16,		// Size
		1,		// bit depth
		0,		// hot spotx
		0,		// hot spoty

		// Cursor shape
		0,0,96,0,112,0,120,0,124,0,126,0,127,0,127,128,
		124,0,108,0,70,0,6,0,3,0,3,0,0,0,0,0,
		
		// Mask shape
		224,0,240,0,248,0,252,0,254,0,255,0,255,128,255,192,
		255,192,254,0,239,0,207,0,7,128,7,128,3,0,0,0
	};

	// Replace the cursors in each of the files.
	for( int fnum = 0; files[fnum].name != NULL; fnum++ )
	{
		BFile file(files[fnum].name, B_READ_WRITE);
		
		if( B_OK != file.InitCheck() )
		{
			printf("Error opening file %s: %s\n Exiting.", files[fnum].name, strerror(file.InitCheck()) );
			return 1;
		}
		
		// Figure out the size of the file.
		file.Seek(0, SEEK_END);
		off_t size = file.Position();
		
		// Allocate and fill a buffer with the whole file.
		unsigned char* buff = new unsigned char[size];
		file.ReadAt(0, buff, size);
		
		// loop through the file looking for the first pattern.
		for( off_t i = 0; i < size; ++i )
		{
			// compare bytes of hand to bytes of file.
			for( int j = 0; j < sizeof(hand); ++j )
			{
				// if it's the same keep comparing
				if( buff[i] == hand[j] )
				{
					// found the hand
					if( j + 1 == sizeof(hand) )
					{
						// set file iterator to the begining of where the hand starts.
						i++;
						i -= sizeof(hand);
						
						printf("In file %s, at location %ld\n", files[fnum].name, i);
						
						// replace 'hand' with 'arrow'
						for( j = 0; j < sizeof(arrow); j++, i++)
						{
							buff[i] = arrow[j];
						}

						// write the new file over the old one.
						file.WriteAt(0, buff, size);
						
						// make the 'i' loop exit.
						i = size;
						continue;
					}
					
					++i;
				}
				else
				{
					// Not the same, increment the index in the file data.
					break;	
				}
			}	
		} 
		
		delete[] buff;
	}

	// Issue warning.
	printf("Good luck! You will need to replace your files with these and "
	       "reboot for this to take affect, don't forget to have "
	       "a boot disk handy in case it goes terribly wrong!\n");
}

